﻿-- Daily Tamer Check
-- by Fluffies
-- EU-Well of Eternity
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")

local dtcicon = "Interface\\ICONS\\INV_MISC_PETMOONKINTA"
local tab = { ["Pandaren Spirits:"] = {
                  [32434] = "Townlong Steppes (Fire Spirit)",
                  [32439] = "Dread Wastes (Water Spirit)",
                  [32441] = "Kun-Lai Summit (Earth Spirit)",
                  [32440] = "The Jade Forest (Air Spirit)"},
               ["Pandaria Tamers:"] = {
                  [31957] = "Dread Wastes (Shu)",
                  [31991] = "Townlong Steppes (Zusshi)",
                  [31956] = "Kun-Lai Summit (Yon)",
                  [31955] = "Valley of the Four Winds (Nishi)",
                  [31954] = "Krasarang Wilds (Mo'ruk)",
                  [31953] = "The Jade Forest (Hyuna)",
                  [31958] = "Vale of Eternal Blossoms (Aki)"},
               ["Other GM Tamers:"] = {
                  [31935] = "Icecrown (Major Payne)",
                  [31926] = "Shadowmoon Valley (Antari)",
                  [31916] = "Deadwind Pass (Lydia Accoste)",
                  [31909] = "Winterspring (Trixxy)",
                  [31971] = "Uldum (Obalis)"} }

-- string colors
local LIGHT_RED   = "|cffFF2020"
local LIGHT_GREEN = "|cff20FF20"
local GREY        = "|cff888888"
local function AddColor(str,color)
 return color..str.."|r"
end

local frame,btnclose

local function DrawTCheckFrame(obj)
 obj:ClearLines();
 obj:AddDoubleLine("Daily Tamer Check","|T"..dtcicon..":32|t");

  table.foreach(tab,function(k,v)
   obj:AddLine(" ");
   obj:AddLine(k);
   table.foreach(v,
    function(questID,questName)
    if IsQuestFlaggedCompleted(questID) then 
     obj:AddDoubleLine(AddColor(questName,GREY),AddColor("done",LIGHT_GREEN))
    else
     obj:AddDoubleLine(AddColor(questName,GREY),AddColor("available",LIGHT_RED))
    end
   end)
  end)
end

local function tamerquestcheck()

 if not frame then
  frame = CreateFrame("GameTooltip", "tchecktooltip", nil, "GameTooltipTemplate");
 end
  frame:SetOwner(UIParent)
  frame:SetFrameStrata("HIGH")  
  frame:EnableMouse(true)
  frame:SetToplevel(true)
  frame:SetMovable()
  frame:SetPadding(16)
  frame:SetScale(0.9)
  frame:RegisterForDrag("LeftButton")
  frame:SetScript("OnDragStart", function(self) 
			self:StartMoving( )
	 end)
  frame:SetScript("OnDragStop", function(self) 
 		self:StopMovingOrSizing()
 	end)
 DrawTCheckFrame(frame)
 frame:AddLine(" ");
 frame:AddLine(" ");
 
 if not btnclose then
  btnclose = CreateFrame("Button", "tcheckbutton", frame, "UIPanelButtonTemplate")
 end
 btnclose:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT",-10,10)
 btnclose:SetWidth(150);
 btnclose:SetText("Close");
 btnclose:SetScript("OnClick", function(self)
  frame:Hide();
 end)
 btnclose:Show();
 frame:Show();
end

local DailyTamerCheck = ldb:NewDataObject("DailyTamerCheck", {
	type = "data source",
	icon = dtcicon,
	label = "Daily Tamer Check",
	OnClick = function(_,button)
         tamerquestcheck();
	end,
	OnTooltipShow = function(tooltip)
		 DrawTCheckFrame(tooltip);
	end,
})

-- slash command
SLASH_DAILYTAMERCHECK1 = "/dtcheck"
SLASH_DAILYTAMERCHECK2 = "/dtc"
SlashCmdList["DAILYTAMERCHECK"] = tamerquestcheck